package mods.immibis.connectedglass;

import java.util.Map;

import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;

import mods.immibis.core.api.CoremodMarker;
import mods.immibis.core.api.FMLModInfo;
import net.minecraft.launchwrapper.IClassTransformer;

import cpw.mods.fml.relauncher.IFMLLoadingPlugin;

@FMLModInfo(
	modid="ConnectedGlass",
	name="Connected Glass",
	url="http://www.minecraftforum.net/topic/1001131-110-immibiss-mods-smp/",
	description="Does what you'd expect from a mod called Connected Glass.",
	authors="immibis"
	)
@CoremodMarker(version="1.2")
public class ConnectedGlass implements IFMLLoadingPlugin {

	@Override
	@Deprecated
	public String[] getLibraryRequestClass() {
		return new String[0];
	}

	@Override
	public String[] getASMTransformerClass() {
		return new String[] {"mods.immibis.connectedglass.ConnectedGlass$Transformer"};
	}

	@Override
	public String getModContainerClass() {
		return null;
	}

	@Override
	public String getSetupClass() {
		return null;
	}

	@Override
	public void injectData(Map<String, Object> data) {
	}
	
	public static class Transformer implements IClassTransformer {
		
		private static class TransformerVisitor extends ClassVisitor {
			public TransformerVisitor(ClassVisitor parent) {
				super(Opcodes.ASM4, parent);
			}
			
			private void generateGetBlockTexture(MethodVisitor mv) {
				mv.visitCode();
				mv.visitVarInsn(Opcodes.ALOAD, 1);
				mv.visitVarInsn(Opcodes.ILOAD, 2);
				mv.visitVarInsn(Opcodes.ILOAD, 3);
				mv.visitVarInsn(Opcodes.ILOAD, 4);
				mv.visitVarInsn(Opcodes.ILOAD, 5);
				mv.visitMethodInsn(Opcodes.INVOKESTATIC, "mods/immibis/connectedglass/Hooks", "getBlockTexture", "(Lnet/minecraft/world/IBlockAccess;IIII)Lnet/minecraft/util/Icon;");
				mv.visitInsn(Opcodes.ARETURN);
				mv.visitMaxs(5, 6);
				mv.visitEnd();
			}
			
			private void generateRegisterIcons(String methodName, MethodVisitor mv) {
				mv.visitCode();
				mv.visitVarInsn(Opcodes.ALOAD, 1);
				mv.visitMethodInsn(Opcodes.INVOKESTATIC, "mods/immibis/connectedglass/Hooks", "registerIcons", "(Lnet/minecraft/client/renderer/texture/IconRegister;)V");
				mv.visitVarInsn(Opcodes.ALOAD, 0);
				mv.visitVarInsn(Opcodes.ALOAD, 1);
				mv.visitMethodInsn(Opcodes.INVOKESPECIAL, "net/minecraft/block/BlockBreakable", methodName, "(Lnet/minecraft/client/renderer/texture/IconRegister;)V");
				mv.visitInsn(Opcodes.RETURN);
				mv.visitMaxs(2, 2);
				mv.visitEnd();
			}
			
			@Override
			public void visitEnd() {
				// obfuscated or not? no idea, so just generate both
				generateGetBlockTexture(super.visitMethod(Opcodes.ACC_PUBLIC, "getBlockTexture", "(Lnet/minecraft/world/IBlockAccess;IIII)Lnet/minecraft/util/Icon;", null, new String[0]));
				generateGetBlockTexture(super.visitMethod(Opcodes.ACC_PUBLIC, "func_71895_b", "(Lnet/minecraft/world/IBlockAccess;IIII)Lnet/minecraft/util/Icon;", null, new String[0]));
				
				generateRegisterIcons("registerIcons", super.visitMethod(Opcodes.ACC_PUBLIC, "registerIcons", "(Lnet/minecraft/client/renderer/texture/IconRegister;)V", null, new String[0]));
				generateRegisterIcons("func_94332_a", super.visitMethod(Opcodes.ACC_PUBLIC, "func_94332_a", "(Lnet/minecraft/client/renderer/texture/IconRegister;)V", null, new String[0]));
				
				super.visitEnd();
			}
		}
		
		private byte[] actuallyTransform(byte[] classdata) {
			ClassWriter cw = new ClassWriter(0);
			new ClassReader(classdata).accept(new TransformerVisitor(cw), 0);
			return cw.toByteArray();
		}
		
		@Override
		public byte[] transform(String arg0, String arg1, byte[] arg2) {
			
			if(arg0.equals("net.minecraft.block.BlockGlass") || arg1.equals("net.minecraft.block.BlockGlass"))
				return actuallyTransform(arg2);
			
			return arg2;
		}
	}

}
